#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char copyr[] = "@(#)(C) Fedon Kadifeli.";
char ident[] = "@(#)" __FILE__ ", Ver 2.2.2, " __DATE__ " " __TIME__;

#define MB (1024*1024)

char data [MB];
char rdata [MB];

int main (int argc, char **argv)
{
  FILE *fp;
  int maxcount = 0;
  int count = 0;
  int i;
  char mode[] = "xb";

  if ((argc != 4 && argc != 3) || (argv[1][0] != 'r' && argv[1][0] != 'w')) {
    fprintf (stderr, "Usage: disktest [r|w] file [MB_count]\n");
    return 1;
  }
  if (argc == 4)
    sscanf (argv[3], "%d", &maxcount);
  mode[0] = argv[1][0];
  if ((fp = fopen (argv[2], mode)) == NULL) {
    perror ("fopen");
    return 2;
  }
  if (setvbuf (fp, NULL, _IOFBF, MB)) {
    perror ("setvbuf");
    return 3;
  }

  for (i=0; i<MB; i++)
    data [i] = (char)( rand () % 256 );

  if (argv[1][0] == 'r') {	/* read data */
    for (count=0; fread(rdata,MB,1,fp)==1; count++) {
      if (memcmp(rdata, data, MB))
        printf ("ERROR: Data mismatch at MB %d!\n", count);
    }
    if (count < maxcount) {
      printf ("Only ");
    } else if (count > maxcount) {
      printf ("More data than requested, or ");
    }
    printf ("%d MB was read.\n", count);
  } else { 			/* write data */
    for (count=0; count<maxcount; count++)
      if (fwrite(data,MB,1,fp)!=1) {
        perror ("fwrite");
        return 4;
      }
    printf ("%d MB was written.\n", count);
  }

  fclose (fp);  
  return 0;
}
